header_patterns = [
    {"label": "SECTION_HEADER", "pattern": [{"text": "FINAL"}, {"text": "DIAGNOSIS"}], "id": "section_FD"},
    {"label": "SECTION_HEADER", "pattern": [{"text": "MICROSCOPIC"}, {"text": "DESCRIPTION"}], "id": "section_MD"},
    {"label": "SECTION_HEADER", "pattern": [{"text": "GROSS"}, {"text": "DESCRIPTION"}], "id": "section_GD"},
    {"label": "SECTION_HEADER", "pattern": [{"text": "COMMENT"}, {"text": ":"}], "id": "section_COM"},
    {"label": "SECTION_HEADER", "pattern": [{"text": "EMBEDDED"}, {"text": "IMAGES"}], "id": "section_EM"},
    {"label": "SECTION_HEADER", "pattern": [{"text": "ADDENDUM"}], "id": "section_ADD"},
    {"label": "SECTION_HEADER", "pattern": [{"text": "INTERPRETATION"}], "id": "section_INT"},
]

polyp_patterns = [
    {"label": "POLYP_HIST", "pattern": [{"LOWER": "tubular"}, {"LOWER": {"REGEX": "adenoma\\(?s?\\)?-?"}}],
     "id": "hist_tubular"},
    {"label": "POLYP_HIST", "pattern": [{"LOWER": "tubulovillous"}, {"LOWER": {"REGEX": "adenoma\\(?s?\\)?-?"}}],
     "id": "hist_tubulo"},
    {"label": "POLYP_HIST", "pattern": [{"LOWER": "villous"}, {"LOWER": {"REGEX": "adenoma\\(?s?\\)?-?"}}],
     "id": "hist_vill"},
    {"label": "POLYP_HIST", "pattern": [{"LOWER": "sessile"}, {"LOWER": "serrated"}], "id": "hist_sess"},
    {"label": "POLYP_HIST", "pattern": [{"LOWER": "sessile"}, {"LOWER": "serrated"}, {
        "LOWER": {"REGEX": "(polyp\\(?s?\\)?)|(lesion\\(?s?\\)?)|(adenoma\\(?s?\\)?)"}}], "id": "hist_sess"},
    {"label": "POLYP_HIST",
     "pattern": [{"LOWER": "traditional"}, {"LOWER": "serrated"}, {"LOWER": {"REGEX": "adenoma\\(?s?\\)?-?"}}],
     "id": "hist_trad"},
    {"label": "POLYP_HIST", "pattern": [{"LOWER": "hyperplastic"}, {"LOWER": {"REGEX": "polyp\\(?s?\\)?-?"}}],
     "id": "hist_hyper"},
    {"label": "POLYP_HIST", "pattern": [{"LOWER": "hyperplastic"}, {"LOWER": {"REGEX": "change\\(?s?\\)?-?"}}],
     "id": "hist_hyper"},
    {"label": "POLYP_HG_DYSPLASIA",
     "pattern": [{"LOWER": "no"}, {"LOWER": "for", "OP": "?"}, {"LOWER": "high"}, {"TEXT": "-", "OP": "?"},
                 {"LOWER": "grade"}, {"LOWER": "dysplasia"}], "id": "hg_dys_no"},
    {"label": "POLYP_HG_DYSPLASIA",
     "pattern": [{"LOWER": "negative"}, {"LOWER": "for", "OP": "?"}, {"LOWER": "high"}, {"TEXT": "-", "OP": "?"},
                 {"LOWER": "grade"}, {"LOWER": "dysplasia"}], "id": "hg_dys_no"},
    {"label": "POLYP_HG_DYSPLASIA", "pattern": [{"LOWER": "no"}, {"LOWER": "dysplasia"}], "id": "hg_dys_no"},
    {"label": "POLYP_HG_DYSPLASIA",
     "pattern": [{"LOWER": "focal", "OP": "?"}, {"LOWER": "high"}, {"TEXT": "-", "OP": "?"}, {"LOWER": "grade"},
                 {"LOWER": "dysplasia"}], "id": "hg_dys_yes"},
    {"label": "POLYP_CYT_DYSPLASIA", "pattern": [{"LOWER": "no"}, {"LOWER": "cytologic"}, {"LOWER": "dysplasia"}],
     "id": "cyt_dys_no"},
    {"label": "POLYP_CYT_DYSPLASIA",
     "pattern": [{"LOWER": "negative"}, {"LOWER": "for", "OP": "?"}, {"LOWER": "cytologic"}, {"LOWER": "dysplasia"}],
     "id": "cyt_dys_no"},
    {"label": "POLYP_CYT_DYSPLASIA",
     "pattern": [{"LOWER": "low"}, {"TEXT": "-", "OP": "?"}, {"LOWER": "grade"}, {"LOWER": "cytologic"},
                 {"LOWER": "dysplasia"}], "id": "cyt_dys_yes"},
    {"label": "POLYP_CYT_DYSPLASIA",
     "pattern": [{"LOWER": "high"}, {"TEXT": "-", "OP": "?"}, {"LOWER": "grade"}, {"LOWER": "cytologic"},
                 {"LOWER": "dysplasia"}], "id": "cyt_dys_yes"},
    {"label": "POLYP_CYT_DYSPLASIA", "pattern": [{"LOWER": "cytologic"}, {"LOWER": "dysplasia"}], "id": "cyt_dys_yes"},
    {"label": "POLYP_SAMPLE_REGEX", "pattern": [{"TEXT": {"REGEX": "[A-W]\\."}}], "id": "final_diag_sample"},
    # {"label": "POLYP_SAMPLE_REGEX",
    #  "pattern": [{"LOWER": "part", "OP": "?"}, {"IS_ALPHA": True, "IS_UPPER": True, "LENGTH": {"==": 1}}],
    #  "id": "gross_desc_sample"},
    {"label": "POLYP_SAMPLE_REGEX",
     "pattern": [{"LOWER": "part", "OP": "?"}, {"TEXT": {"REGEX": "[A-W](-\\s?\\d|\\.)"}}], "id": "gross_desc_sample"},
    {"label": "POLYP_SAMPLE", "pattern": [{"TEXT": {"REGEX": "POLYPS?"}}], "id": "final_diag_sample"},
    {"label": "POLYP_SAMPLE", "pattern": [{"TEXT": "POLYPECTOMY"}], "id": "final_diag_sample"},
    {"label": "MALIGNANCY",
     "pattern": [{"LOWER": {"IN": ["sarcoid", "malignant", "malignancy", "carcinoid", "lymphoma"]}},
                 {"LOWER": "tumor", "OP": "?"}
                 ]},
    {"label": "MALIGNANCY", "pattern": [{"LOWER": "invasive", "OP": "?"}, {"LOWER": {"REGEX": "(adeno)?carcinoma"}}]},
    {"label": "MALIGNANCY", "pattern": [{"LOWER": "neuroendocrine"}, {"LOWER": "tumor"}]},
    {"label": "MALIGNANCY", "pattern": [{"TEXT": "NET"}]},
]
